]> git.ipfire.org Git - ipfire-2.x.git/blob - make.sh
make.sh: Modify update-contributors so that it will run with older version of awk
[ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2007-2019 IPFire Team <info@ipfire.org>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 # If you update the version don't forget to update backupiso and add it to core update
28 VERSION="2.25" # Version number
29 CORE="141" # Core Level (Filename)
30 PAKFIRE_CORE="141" # Core Level (PAKFIRE)
31 GIT_BRANCH=`git rev-parse --abbrev-ref HEAD` # Git Branch
32 SLOGAN="www.ipfire.org" # Software slogan
33 CONFIG_ROOT=/var/ipfire # Configuration rootdir
34 NICE=10 # Nice level
35 MAX_RETRIES=1 # prefetch/check loop
36 BUILD_IMAGES=1 # Flash and Xen Downloader
37 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
38 GIT_TAG=$(git tag | tail -1) # Git Tag
39 GIT_LASTCOMMIT=$(git log | head -n1 | cut -d" " -f2 |head -c8) # Last commit
40
41 TOOLCHAINVER=20200108
42
43 ###############################################################################
44 #
45 # Beautifying variables & presentation & input output interface
46 #
47 ###############################################################################
48
49 # Remember if the shell is interactive or not
50 if [ -t 0 ] && [ -t 1 ]; then
51 INTERACTIVE=true
52 else
53 INTERACTIVE=false
54 fi
55
56 # Sets or adjusts pretty formatting variables
57 resize_terminal() {
58 ## Screen Dimentions
59 # Find current screen size
60 COLUMNS=$(tput cols)
61
62 # When using remote connections, such as a serial port, stty size returns 0
63 if ! ${INTERACTIVE} || [ "${COLUMNS}" = "0" ]; then
64 COLUMNS=80
65 fi
66
67 # Measurements for positioning result messages
68 OPTIONS_WIDTH=20
69 TIME_WIDTH=12
70 STATUS_WIDTH=8
71 NAME_WIDTH=$(( COLUMNS - OPTIONS_WIDTH - TIME_WIDTH - STATUS_WIDTH ))
72 LINE_WIDTH=$(( COLUMNS - STATUS_WIDTH ))
73
74 TIME_COL=$(( NAME_WIDTH + OPTIONS_WIDTH ))
75 STATUS_COL=$(( TIME_COL + TIME_WIDTH ))
76 }
77
78 # Initially setup terminal
79 resize_terminal
80
81 # Call resize_terminal when terminal is being resized
82 trap "resize_terminal" WINCH
83
84 # Define color for messages
85 BOLD="\\033[1;39m"
86 DONE="\\033[1;32m"
87 SKIP="\\033[1;34m"
88 WARN="\\033[1;35m"
89 FAIL="\\033[1;31m"
90 NORMAL="\\033[0;39m"
91
92 # New architecture variables
93 HOST_ARCH="$(uname -m)"
94
95 PWD=$(pwd)
96 BASENAME=$(basename $0)
97
98 # Debian specific settings
99 if [ ! -e /etc/debian_version ]; then
100 FULLPATH=`which $0`
101 else
102 if [ -x /usr/bin/realpath ]; then
103 FULLPATH=`/usr/bin/realpath $0`
104 else
105 echo "ERROR: Need to do apt-get install realpath"
106 exit 1
107 fi
108 fi
109
110 # This is the directory where make.sh is in
111 export BASEDIR=$(echo $FULLPATH | sed "s/\/$BASENAME//g")
112
113 LOGFILE=$BASEDIR/log/_build.preparation.log
114 export LOGFILE
115 DIR_CHK=$BASEDIR/cache/check
116 mkdir $BASEDIR/log/ 2>/dev/null
117
118 system_processors() {
119 getconf _NPROCESSORS_ONLN 2>/dev/null || echo "1"
120 }
121
122 system_memory() {
123 local key val unit
124
125 while read -r key val unit; do
126 case "${key}" in
127 MemTotal:*)
128 # Convert to MB
129 echo "$(( ${val} / 1024 ))"
130 break
131 ;;
132 esac
133 done < /proc/meminfo
134 }
135
136 configure_build() {
137 local build_arch="${1}"
138
139 if [ "${build_arch}" = "default" ]; then
140 build_arch="$(configure_build_guess)"
141 fi
142
143 case "${build_arch}" in
144 x86_64)
145 BUILDTARGET="${build_arch}-unknown-linux-gnu"
146 CROSSTARGET="${build_arch}-cross-linux-gnu"
147 BUILD_PLATFORM="x86"
148 CFLAGS_ARCH="-m64 -mindirect-branch=thunk -mfunction-return=thunk -mtune=generic"
149 ;;
150
151 i586)
152 BUILDTARGET="${build_arch}-pc-linux-gnu"
153 CROSSTARGET="${build_arch}-cross-linux-gnu"
154 BUILD_PLATFORM="x86"
155 CFLAGS_ARCH="-march=i586 -mindirect-branch=thunk -mfunction-return=thunk -mtune=generic -fomit-frame-pointer"
156 ;;
157
158 aarch64)
159 BUILDTARGET="${build_arch}-unknown-linux-gnu"
160 CROSSTARGET="${build_arch}-cross-linux-gnu"
161 BUILD_PLATFORM="arm"
162 CFLAGS_ARCH=""
163 ;;
164
165 armv7hl)
166 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
167 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
168 BUILD_PLATFORM="arm"
169 CFLAGS_ARCH="-march=armv7-a -mfpu=vfpv3-d16 -mfloat-abi=hard"
170 ;;
171
172 armv5tel)
173 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
174 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
175 BUILD_PLATFORM="arm"
176 CFLAGS_ARCH="-march=armv5te -mfloat-abi=soft -fomit-frame-pointer"
177 RUSTFLAGS="-Ccodegen-units=1"
178 ;;
179
180 *)
181 exiterror "Cannot build for architure ${build_arch}"
182 ;;
183 esac
184
185 # Check if the QEMU helper is available if needed.
186 if qemu_is_required "${build_arch}"; then
187 local qemu_build_helper="$(qemu_find_build_helper_name "${build_arch}")"
188
189 if [ -n "${qemu_build_helper}" ]; then
190 QEMU_TARGET_HELPER="${qemu_build_helper}"
191 else
192 exiterror "Could not find a binfmt_misc helper entry for ${build_arch}"
193 fi
194 fi
195
196 BUILD_ARCH="${build_arch}"
197 TOOLS_DIR="/tools_${BUILD_ARCH}"
198
199 # Enables hardening
200 HARDENING_CFLAGS="-Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -fstack-protector-strong"
201
202 CFLAGS="-O2 -pipe -Wall -fexceptions -fPIC ${CFLAGS_ARCH}"
203 CXXFLAGS="${CFLAGS}"
204
205 # Determine parallelism
206 # We assume that each process consumes about
207 # 128MB of memory. Therefore we find out how
208 # many processes fit into memory.
209 local mem_max=$(( ${SYSTEM_MEMORY} / 128 ))
210 local cpu_max=$(( ${SYSTEM_PROCESSORS} + 1 ))
211
212 local parallelism
213 if [ ${mem_max} -lt ${cpu_max} ]; then
214 parallelism=${mem_max}
215 else
216 parallelism=${cpu_max}
217 fi
218
219 # Use this as default PARALLELISM
220 DEFAULT_PARALLELISM="${parallelism}"
221
222 # Compression parameters
223 # We use mode 8 for reasonable memory usage when decompressing
224 # but with overall good compression
225 XZ_OPT="-8"
226
227 # We try to use as many cores as possible
228 XZ_OPT="${XZ_OPT} -T0"
229
230 # We need to limit memory because XZ uses too much when running
231 # in parallel and it isn't very smart in limiting itself.
232 # We allow XZ to use up to 70% of all system memory.
233 local xz_memory=$(( SYSTEM_MEMORY * 7 / 10 ))
234
235 # XZ memory cannot be larger than 2GB on 32 bit systems
236 case "${build_arch}" in
237 i*86|armv*)
238 if [ ${xz_memory} -gt 2048 ]; then
239 xz_memory=2048
240 fi
241 ;;
242 esac
243
244 XZ_OPT="${XZ_OPT} --memory=${xz_memory}MiB"
245 }
246
247 configure_build_guess() {
248 case "${HOST_ARCH}" in
249 x86_64)
250 echo "x86_64"
251 ;;
252 i?86)
253 echo "i586"
254 ;;
255
256 aarch64)
257 echo "aarch64"
258 ;;
259
260 armv7*|armv6*|armv5*)
261 echo "armv5tel"
262 ;;
263
264 *)
265 exiterror "Cannot guess build architecture"
266 ;;
267 esac
268 }
269
270 stdumount() {
271 umount $BASEDIR/build/sys 2>/dev/null;
272 umount $BASEDIR/build/dev/shm 2>/dev/null;
273 umount $BASEDIR/build/dev/pts 2>/dev/null;
274 umount $BASEDIR/build/dev 2>/dev/null;
275 umount $BASEDIR/build/proc 2>/dev/null;
276 umount $BASEDIR/build/install/mnt 2>/dev/null;
277 umount $BASEDIR/build/usr/src/cache 2>/dev/null;
278 umount $BASEDIR/build/usr/src/ccache 2>/dev/null;
279 umount $BASEDIR/build/usr/src/config 2>/dev/null;
280 umount $BASEDIR/build/usr/src/doc 2>/dev/null;
281 umount $BASEDIR/build/usr/src/html 2>/dev/null;
282 umount $BASEDIR/build/usr/src/langs 2>/dev/null;
283 umount $BASEDIR/build/usr/src/lfs 2>/dev/null;
284 umount $BASEDIR/build/usr/src/log 2>/dev/null;
285 umount $BASEDIR/build/usr/src/src 2>/dev/null;
286 umount $BASEDIR/build/usr/src 2>/dev/null;
287 }
288
289 now() {
290 date -u "+%s"
291 }
292
293 format_runtime() {
294 local seconds=${1}
295
296 if [ ${seconds} -ge 3600 ]; then
297 printf "%d:%02d:%02d\n" \
298 "$(( seconds / 3600 ))" \
299 "$(( seconds % 3600 / 60 ))" \
300 "$(( seconds % 3600 % 60 ))"
301 elif [ ${seconds} -ge 60 ]; then
302 printf "%d:%02d\n" \
303 "$(( seconds / 60 ))" \
304 "$(( seconds % 60 ))"
305 else
306 printf "%d\n" "${seconds}"
307 fi
308 }
309
310 print_line() {
311 local line="$@"
312
313 printf "%-${LINE_WIDTH}s" "${line}"
314 }
315
316 _print_line() {
317 local status="${1}"
318 shift
319
320 if ${INTERACTIVE}; then
321 printf "${!status}"
322 fi
323
324 print_line "$@"
325
326 if ${INTERACTIVE}; then
327 printf "${NORMAL}"
328 fi
329 }
330
331 print_headline() {
332 _print_line BOLD "$@"
333 }
334
335 print_error() {
336 _print_line FAIL "$@"
337 }
338
339 print_package() {
340 local name="${1}"
341 shift
342
343 local version="$(grep -E "^VER |^VER=|^VER " $BASEDIR/lfs/${name} | awk '{ print $3 }')"
344 local options="$@"
345
346 local string="${name}"
347 if [ -n "${version}" ] && [ "${version}" != "ipfire" ]; then
348 string="${string} (${version})"
349 fi
350
351 printf "%-$(( ${NAME_WIDTH} - 1 ))s " "${string}"
352 printf "%$(( ${OPTIONS_WIDTH} - 1 ))s " "${options}"
353 }
354
355 print_runtime() {
356 local runtime=$(format_runtime $@)
357
358 if ${INTERACTIVE}; then
359 printf "\\033[${TIME_COL}G[ ${BOLD}%$(( ${TIME_WIDTH} - 4 ))s${NORMAL} ]" "${runtime}"
360 else
361 printf "[ %$(( ${TIME_WIDTH} - 4 ))s ]" "${runtime}"
362 fi
363 }
364
365 print_status() {
366 local status="${1}"
367
368 local color="${!status}"
369
370 if ${INTERACTIVE}; then
371 printf "\\033[${STATUS_COL}G[${color-${BOLD}} %-$(( ${STATUS_WIDTH} - 4 ))s ${NORMAL}]\n" "${status}"
372 else
373 printf "[ %-$(( ${STATUS_WIDTH} - 4 ))s ]\n" "${status}"
374 fi
375 }
376
377 print_build_stage() {
378 print_headline "$@"
379
380 # end line
381 printf "\n"
382 }
383
384 print_build_summary() {
385 local runtime=$(format_runtime $@)
386
387 print_line "*** Build finished in ${runtime}"
388 print_status DONE
389 }
390
391 exiterror() {
392 stdumount
393 for i in `seq 0 7`; do
394 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
395 losetup -d /dev/loop${i} 2>/dev/null
396 fi;
397 done
398
399 # Dump logfile
400 if [ -n "${LOGFILE}" ] && [ -e "${LOGFILE}" ]; then
401 echo # empty line
402
403 local line
404 while read -r line; do
405 echo " ${line}"
406 done <<< "$(tail -n30 ${LOGFILE})"
407 fi
408
409 echo # empty line
410
411 local line
412 for line in "ERROR: $@" " Check ${LOGFILE} for errors if applicable"; do
413 print_error "${line}"
414 print_status FAIL
415 done
416
417 exit 1
418 }
419
420 prepareenv() {
421 # Are we running the right shell?
422 if [ -z "${BASH}" ]; then
423 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
424 fi
425
426 if [ -z "${BASH_VERSION}" ]; then
427 exiterror "Not running BASH shell."
428 fi
429
430 # Trap on emergency exit
431 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
432
433 # Resetting our nice level
434 if ! renice ${NICE} $$ >/dev/null; then
435 exiterror "Failed to set nice level to ${NICE}"
436 fi
437
438 # Checking if running as root user
439 if [ $(id -u) -ne 0 ]; then
440 exiterror "root privileges required for building"
441 fi
442
443 # Checking for necessary temporary space
444 print_line "Checking for necessary space on disk $BASE_DEV"
445 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
446 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
447 if (( 2048000 > $BASE_ASPACE )); then
448 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
449 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
450 print_status FAIL
451 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
452 fi
453 else
454 print_status DONE
455 fi
456
457 # Set umask
458 umask 022
459
460 # Set LFS Directory
461 LFS=$BASEDIR/build
462
463 # Setup environment
464 set +h
465 LC_ALL=POSIX
466 export LFS LC_ALL CFLAGS CXXFLAGS DEFAULT_PARALLELISM RUSTFLAGS
467 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
468
469 # Make some extra directories
470 mkdir -p "${BASEDIR}/build${TOOLS_DIR}" 2>/dev/null
471 mkdir -p $BASEDIR/build/{etc,usr/src} 2>/dev/null
472 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
473 mkdir -p $BASEDIR/{cache,ccache/${BUILD_ARCH}} 2>/dev/null
474
475 if [ "${ENABLE_RAMDISK}" = "on" ]; then
476 mkdir -p $BASEDIR/build/usr/src
477 mount -t tmpfs tmpfs -o size=4G,nr_inodes=1M,mode=1777 $BASEDIR/build/usr/src
478 fi
479
480 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
481
482 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
483 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
484
485 # Make all sources and proc available under lfs build
486 mount --bind /dev $BASEDIR/build/dev
487 mount --bind /dev/pts $BASEDIR/build/dev/pts
488 mount --bind /dev/shm $BASEDIR/build/dev/shm
489 mount --bind /proc $BASEDIR/build/proc
490 mount --bind /sys $BASEDIR/build/sys
491 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
492 mount --bind $BASEDIR/ccache/${BUILD_ARCH} $BASEDIR/build/usr/src/ccache
493 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
494 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
495 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
496 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
497 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
498 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
499 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
500
501 # Run LFS static binary creation scripts one by one
502 export CCACHE_DIR=$BASEDIR/ccache
503 export CCACHE_COMPRESS=1
504 export CCACHE_COMPILERCHECK="string:toolchain-${TOOLCHAINVER} ${BUILD_ARCH}"
505
506 # Remove pre-install list of installed files in case user erase some files before rebuild
507 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
508
509 # Prepare string for /etc/system-release.
510 SYSTEM_RELEASE="${NAME} ${VERSION} (${BUILD_ARCH})"
511 if [ "$(git status -s | wc -l)" == "0" ]; then
512 GIT_STATUS=""
513 else
514 GIT_STATUS="-dirty"
515 fi
516 case "$GIT_BRANCH" in
517 core*|beta?|rc?)
518 SYSTEM_RELEASE="${SYSTEM_RELEASE} - $GIT_BRANCH$GIT_STATUS"
519 ;;
520 *)
521 SYSTEM_RELEASE="${SYSTEM_RELEASE} - Development Build: $GIT_BRANCH/$GIT_LASTCOMMIT$GIT_STATUS"
522 ;;
523 esac
524
525 # Setup ccache cache size
526 enterchroot ccache --max-size="${CCACHE_CACHE_SIZE}" >/dev/null
527 }
528
529 enterchroot() {
530 # Install QEMU helper, if needed
531 qemu_install_helper
532
533 local PATH="${TOOLS_DIR}/ccache/bin:/bin:/usr/bin:/sbin:/usr/sbin:${TOOLS_DIR}/bin"
534
535 PATH="${PATH}" chroot ${LFS} env -i \
536 HOME="/root" \
537 TERM="${TERM}" \
538 PS1="${PS1}" \
539 PATH="${PATH}" \
540 SYSTEM_RELEASE="${SYSTEM_RELEASE}" \
541 PAKFIRE_CORE="${PAKFIRE_CORE}" \
542 NAME="${NAME}" \
543 SNAME="${SNAME}" \
544 VERSION="${VERSION}" \
545 CORE="${CORE}" \
546 SLOGAN="${SLOGAN}" \
547 TOOLS_DIR="${TOOLS_DIR}" \
548 CONFIG_ROOT="${CONFIG_ROOT}" \
549 CFLAGS="${CFLAGS} ${HARDENING_CFLAGS}" \
550 CXXFLAGS="${CXXFLAGS} ${HARDENING_CFLAGS}" \
551 RUSTFLAGS="${RUSTFLAGS}" \
552 BUILDTARGET="${BUILDTARGET}" \
553 CROSSTARGET="${CROSSTARGET}" \
554 BUILD_ARCH="${BUILD_ARCH}" \
555 BUILD_PLATFORM="${BUILD_PLATFORM}" \
556 CCACHE_DIR=/usr/src/ccache \
557 CCACHE_COMPRESS="${CCACHE_COMPRESS}" \
558 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
559 GOCACHE="/usr/src/ccache/go" \
560 KVER="${KVER}" \
561 XZ_OPT="${XZ_OPT}" \
562 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
563 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
564 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
565 $(fake_environ) \
566 $(qemu_environ) \
567 "$@"
568 }
569
570 entershell() {
571 if [ ! -e $BASEDIR/build/usr/src/lfs/ ]; then
572 exiterror "No such file or directory: $BASEDIR/build/usr/src/lfs/"
573 fi
574
575 echo "Entering to a shell inside LFS chroot, go out with exit"
576 local PS1="ipfire build chroot (${BUILD_ARCH}) \u:\w\$ "
577
578 if enterchroot bash -i; then
579 stdumount
580 else
581 print_status FAIL
582 exiterror "chroot error"
583 fi
584 }
585
586 lfsmakecommoncheck() {
587 # Script present?
588 if [ ! -f $BASEDIR/lfs/$1 ]; then
589 exiterror "No such file or directory: $BASEDIR/$1"
590 fi
591
592 # Print package name and version
593 print_package $@
594
595 # Check if this package is supported by our architecture.
596 # If no SUP_ARCH is found, we assume the package can be built for all.
597 if grep "^SUP_ARCH" ${BASEDIR}/lfs/${1} >/dev/null; then
598 # Check if package supports ${BUILD_ARCH} or all architectures.
599 if ! grep -E "^SUP_ARCH.*${BUILD_ARCH}|^SUP_ARCH.*all" ${BASEDIR}/lfs/${1} >/dev/null; then
600 print_runtime 0
601 print_status SKIP
602 return 1
603 fi
604 fi
605
606 # Script slipped?
607 local i
608 for i in $SKIP_PACKAGE_LIST
609 do
610 if [ "$i" == "$1" ]; then
611 print_status SKIP
612 return 1;
613 fi
614 done
615
616 echo -ne "`date -u '+%b %e %T'`: Building $* " >> $LOGFILE
617
618 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
619 MESSAGE="$1\t " download >> $LOGFILE 2>&1
620 if [ $? -ne 0 ]; then
621 exiterror "Download error in $1"
622 fi
623
624 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
625 MESSAGE="$1\t md5sum" md5 >> $LOGFILE 2>&1
626 if [ $? -ne 0 ]; then
627 exiterror "md5sum error in $1, check file in cache or signature"
628 fi
629
630 return 0 # pass all!
631 }
632
633 lfsmake1() {
634 lfsmakecommoncheck $*
635 [ $? == 1 ] && return 0
636
637 cd $BASEDIR/lfs && env -i \
638 PATH="${TOOLS_DIR}/ccache/bin:${TOOLS_DIR}/bin:$PATH" \
639 CCACHE_DIR="${CCACHE_DIR}" \
640 CCACHE_COMPRESS="${CCACHE_COMPRESS}" \
641 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
642 CFLAGS="${CFLAGS}" \
643 CXXFLAGS="${CXXFLAGS}" \
644 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
645 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
646 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
647 make -f $* \
648 TOOLCHAIN=1 \
649 TOOLS_DIR="${TOOLS_DIR}" \
650 CROSSTARGET="${CROSSTARGET}" \
651 BUILDTARGET="${BUILDTARGET}" \
652 BUILD_ARCH="${BUILD_ARCH}" \
653 BUILD_PLATFORM="${BUILD_PLATFORM}" \
654 LFS_BASEDIR="${BASEDIR}" \
655 ROOT="${LFS}" \
656 KVER="${KVER}" \
657 install >> $LOGFILE 2>&1 &
658
659 if ! wait_until_finished $!; then
660 print_status FAIL
661 exiterror "Building $*"
662 fi
663
664 print_status DONE
665 }
666
667 lfsmake2() {
668 lfsmakecommoncheck $*
669 [ $? == 1 ] && return 0
670
671 local PS1='\u:\w$ '
672
673 enterchroot \
674 ${EXTRA_PATH}bash -x -c "cd /usr/src/lfs && \
675 make -f $* \
676 LFS_BASEDIR=/usr/src install" \
677 >> ${LOGFILE} 2>&1 &
678
679 if ! wait_until_finished $!; then
680 print_status FAIL
681 exiterror "Building $*"
682 fi
683
684 print_status DONE
685 }
686
687 ipfiredist() {
688 lfsmakecommoncheck $*
689 [ $? == 1 ] && return 0
690
691 local PS1='\u:\w$ '
692
693 enterchroot \
694 bash -x -c "cd /usr/src/lfs && make -f $* LFS_BASEDIR=/usr/src dist" \
695 >> ${LOGFILE} 2>&1 &
696
697 if ! wait_until_finished $!; then
698 print_status FAIL
699 exiterror "Packaging $*"
700 fi
701
702 print_status DONE
703 }
704
705 wait_until_finished() {
706 local pid=${1}
707
708 local start_time=$(now)
709
710 # Show progress
711 if ${INTERACTIVE}; then
712 # Wait a little just in case the process
713 # has finished very quickly.
714 sleep 0.1
715
716 local runtime
717 while kill -0 ${pid} 2>/dev/null; do
718 print_runtime $(( $(now) - ${start_time} ))
719
720 # Wait a little
721 sleep 1
722 done
723 fi
724
725 # Returns the exit code of the child process
726 wait ${pid}
727 local ret=$?
728
729 if ! ${INTERACTIVE}; then
730 print_runtime $(( $(now) - ${start_time} ))
731 fi
732
733 return ${ret}
734 }
735
736 fake_environ() {
737 [ -e "${BASEDIR}/build${TOOLS_DIR}/lib/libpakfire_preload.so" ] || return
738
739 local env="LD_PRELOAD=${TOOLS_DIR}/lib/libpakfire_preload.so"
740
741 # Fake kernel version, because some of the packages do not compile
742 # with kernel 3.0 and later.
743 env="${env} UTS_RELEASE=${KVER}-ipfire"
744
745 # Fake machine version.
746 env="${env} UTS_MACHINE=${BUILD_ARCH}"
747
748 echo "${env}"
749 }
750
751 qemu_environ() {
752 local env
753
754 # Don't add anything if qemu is not used.
755 if ! qemu_is_required; then
756 return
757 fi
758
759 # Set default qemu options
760 case "${BUILD_ARCH}" in
761 arm*)
762 QEMU_CPU="${QEMU_CPU:-cortex-a9}"
763
764 env="${env} QEMU_CPU=${QEMU_CPU}"
765 ;;
766 esac
767
768 # Enable QEMU strace
769 #env="${env} QEMU_STRACE=1"
770
771 echo "${env}"
772 }
773
774 qemu_is_required() {
775 local build_arch="${1}"
776
777 if [ -z "${build_arch}" ]; then
778 build_arch="${BUILD_ARCH}"
779 fi
780
781 case "${HOST_ARCH},${build_arch}" in
782 x86_64,arm*|i?86,arm*|i?86,x86_64)
783 return 0
784 ;;
785 *)
786 return 1
787 ;;
788 esac
789 }
790
791 qemu_install_helper() {
792 # Do nothing, if qemu is not required
793 if ! qemu_is_required; then
794 return 0
795 fi
796
797 if [ ! -e /proc/sys/fs/binfmt_misc/status ]; then
798 exiterror "binfmt_misc not mounted. QEMU_TARGET_HELPER not useable."
799 fi
800
801 if [ ! $(cat /proc/sys/fs/binfmt_misc/status) = 'enabled' ]; then
802 exiterror "binfmt_misc not enabled. QEMU_TARGET_HELPER not useable."
803 fi
804
805
806 if [ -z "${QEMU_TARGET_HELPER}" ]; then
807 exiterror "QEMU_TARGET_HELPER not set"
808 fi
809
810 # Check if the helper is already installed.
811 if [ -x "${LFS}${QEMU_TARGET_HELPER}" ]; then
812 return 0
813 fi
814
815 # Try to find a suitable binary that we can install
816 # to the build environment.
817 local file
818 for file in "${QEMU_TARGET_HELPER}" "${QEMU_TARGET_HELPER}-static"; do
819 # file must exist and be executable.
820 [ -x "${file}" ] || continue
821
822 # Must be static.
823 file_is_static "${file}" || continue
824
825 local dirname="${LFS}$(dirname "${file}")"
826 mkdir -p "${dirname}"
827
828 install -m 755 "${file}" "${LFS}${QEMU_TARGET_HELPER}"
829 return 0
830 done
831
832 exiterror "Could not find a statically-linked QEMU emulator: ${QEMU_TARGET_HELPER}"
833 }
834
835 qemu_find_build_helper_name() {
836 local build_arch="${1}"
837
838 local magic
839 case "${build_arch}" in
840 arm*)
841 magic="7f454c4601010100000000000000000002002800"
842 ;;
843 x86_64)
844 magic="7f454c4602010100000000000000000002003e00"
845 ;;
846 esac
847
848 [ -z "${magic}" ] && return 1
849
850 local file
851 for file in /proc/sys/fs/binfmt_misc/*; do
852 # skip write only register entry
853 [ $(basename "${file}") = "register" ] && continue
854 # Search for the file with the correct magic value.
855 grep -qE "^magic ${magic}$" "${file}" || continue
856
857 local interpreter="$(grep "^interpreter" "${file}" | awk '{ print $2 }')"
858
859 [ -n "${interpreter}" ] || continue
860 [ "${interpreter:0:1}" = "/" ] || continue
861 [ -x "${interpreter}" ] || continue
862
863 echo "${interpreter}"
864 return 0
865 done
866
867 return 1
868 }
869
870 file_is_static() {
871 local file="${1}"
872
873 file ${file} 2>/dev/null | grep -q "statically linked"
874 }
875
876 update_language_list() {
877 local path="${1}"
878
879 local lang
880 for lang in ${path}/*.po; do
881 lang="$(basename "${lang}")"
882 echo "${lang%*.po}"
883 done | sort -u > "${path}/LINGUAS"
884 }
885
886 contributors() {
887 local commits name
888
889 git shortlog --summary --numbered | while read -r commits name; do
890 echo "${name}"
891 done | grep -vE -e "^(alpha197|morlix|root|ummeegge)$" -e "via Development$" -e "@" -e "#$"
892 }
893
894 update_contributors() {
895 echo -n "Updating list of contributors"
896
897 local contributors="$(contributors | paste -sd , - | sed -e "s/,/&\\\\n/g")"
898
899 # Edit contributors into credits.cgi
900 local tmp="$(mktemp)"
901
902 awk "/<!-- CONTRIBUTORS -->/{ p=1; print; printf \"${contributors}\n\"}/<!-- END -->/{ p=0 } !p" \
903 < "${BASEDIR}/html/cgi-bin/credits.cgi" > "${tmp}"
904
905 # Copy back modified content
906 cat "${tmp}" > "${BASEDIR}/html/cgi-bin/credits.cgi"
907 unlink "${tmp}"
908
909 print_status DONE
910 return 0
911 }
912
913 # Default settings
914 CCACHE_CACHE_SIZE="4G"
915 ENABLE_RAMDISK="auto"
916
917 # Load configuration file
918 if [ -f .config ]; then
919 . .config
920 fi
921
922 # TARGET_ARCH is BUILD_ARCH now
923 if [ -n "${TARGET_ARCH}" ]; then
924 BUILD_ARCH="${TARGET_ARCH}"
925 unset TARGET_ARCH
926 fi
927
928 # Get some information about the host system
929 SYSTEM_PROCESSORS="$(system_processors)"
930 SYSTEM_MEMORY="$(system_memory)"
931
932 if [ -n "${BUILD_ARCH}" ]; then
933 configure_build "${BUILD_ARCH}"
934 else
935 configure_build "default"
936 fi
937
938 # Automatically enable/disable ramdisk usage
939 if [ "${ENABLE_RAMDISK}" = "auto" ]; then
940 # Enable only when the host system has 4GB of RAM or more
941 if [ ${SYSTEM_MEMORY} -ge 3900 ]; then
942 ENABLE_RAMDISK="on"
943 fi
944 fi
945
946 buildtoolchain() {
947 local error=false
948 case "${BUILD_ARCH}:${HOST_ARCH}" in
949 # x86_64
950 x86_64:x86_64)
951 # This is working.
952 ;;
953
954 # x86
955 i586:i586|i586:i686|i586:x86_64)
956 # These are working.
957 ;;
958 i586:*)
959 error=true
960 ;;
961
962 # ARM
963 arvm7hl:armv7hl|armv7hl:armv7l)
964 # These are working.
965 ;;
966
967 armv5tel:armv5tel|armv5tel:armv5tejl|armv5tel:armv6l|armv5tel:armv7l|armv5tel:aarch64)
968 # These are working.
969 ;;
970 armv5tel:*)
971 error=true
972 ;;
973 esac
974
975 ${error} && \
976 exiterror "Cannot build ${BUILD_ARCH} toolchain on $(uname -m). Please use the download if any."
977
978 local gcc=$(type -p gcc)
979 if [ -z "${gcc}" ]; then
980 exiterror "Could not find GCC. You will need a working build enviroment in order to build the toolchain."
981 fi
982
983 # Check ${TOOLS_DIR} symlink
984 if [ -h "${TOOLS_DIR}" ]; then
985 rm -f "${TOOLS_DIR}"
986 fi
987
988 if [ ! -e "${TOOLS_DIR}" ]; then
989 ln -s "${BASEDIR}/build${TOOLS_DIR}" "${TOOLS_DIR}"
990 fi
991
992 if [ ! -h "${TOOLS_DIR}" ]; then
993 exiterror "Could not create ${TOOLS_DIR} symbolic link"
994 fi
995
996 LOGFILE="$BASEDIR/log/_build.toolchain.log"
997 export LOGFILE
998
999 lfsmake1 stage1
1000 lfsmake1 ccache PASS=1
1001 lfsmake1 binutils PASS=1
1002 lfsmake1 gcc PASS=1
1003 lfsmake1 linux KCFG="-headers"
1004 lfsmake1 glibc
1005 lfsmake1 gcc PASS=L
1006 lfsmake1 binutils PASS=2
1007 lfsmake1 gcc PASS=2
1008 lfsmake1 zlib
1009 lfsmake1 ccache PASS=2
1010 lfsmake1 tcl
1011 lfsmake1 expect
1012 lfsmake1 dejagnu
1013 lfsmake1 pkg-config
1014 lfsmake1 ncurses
1015 lfsmake1 bash
1016 lfsmake1 bzip2
1017 lfsmake1 automake
1018 lfsmake1 coreutils
1019 lfsmake1 diffutils
1020 lfsmake1 findutils
1021 lfsmake1 gawk
1022 lfsmake1 gettext
1023 lfsmake1 grep
1024 lfsmake1 gzip
1025 lfsmake1 m4
1026 lfsmake1 make
1027 lfsmake1 patch
1028 lfsmake1 perl
1029 lfsmake1 python3
1030 lfsmake1 sed
1031 lfsmake1 tar
1032 lfsmake1 texinfo
1033 lfsmake1 xz
1034 lfsmake1 bison
1035 lfsmake1 flex
1036 lfsmake1 fake-environ
1037 lfsmake1 strip
1038 lfsmake1 cleanup-toolchain
1039 }
1040
1041 buildbase() {
1042 LOGFILE="$BASEDIR/log/_build.base.log"
1043 export LOGFILE
1044 lfsmake2 stage2
1045 lfsmake2 linux KCFG="-headers"
1046 lfsmake2 man-pages
1047 lfsmake2 glibc
1048 lfsmake2 tzdata
1049 lfsmake2 cleanup-toolchain
1050 lfsmake2 zlib
1051 lfsmake2 binutils
1052 lfsmake2 gmp
1053 lfsmake2 gmp-compat
1054 lfsmake2 mpfr
1055 lfsmake2 libmpc
1056 lfsmake2 file
1057 lfsmake2 gcc
1058 lfsmake2 sed
1059 lfsmake2 autoconf
1060 lfsmake2 automake
1061 lfsmake2 berkeley
1062 lfsmake2 coreutils
1063 lfsmake2 iana-etc
1064 lfsmake2 m4
1065 lfsmake2 bison
1066 lfsmake2 ncurses
1067 lfsmake2 procps
1068 lfsmake2 libtool
1069 lfsmake2 perl
1070 lfsmake2 readline
1071 lfsmake2 readline-compat
1072 lfsmake2 bzip2
1073 lfsmake2 xz
1074 lfsmake2 pcre
1075 lfsmake2 pcre-compat
1076 lfsmake2 bash
1077 lfsmake2 diffutils
1078 lfsmake2 e2fsprogs
1079 lfsmake2 ed
1080 lfsmake2 findutils
1081 lfsmake2 flex
1082 lfsmake2 gawk
1083 lfsmake2 gettext
1084 lfsmake2 grep
1085 lfsmake2 groff
1086 lfsmake2 gperf
1087 lfsmake2 gzip
1088 lfsmake2 hostname
1089 lfsmake2 iproute2
1090 lfsmake2 jwhois
1091 lfsmake2 kbd
1092 lfsmake2 less
1093 lfsmake2 pkg-config
1094 lfsmake2 make
1095 lfsmake2 man
1096 lfsmake2 kmod
1097 lfsmake2 net-tools
1098 lfsmake2 patch
1099 lfsmake2 psmisc
1100 lfsmake2 shadow
1101 lfsmake2 sysklogd
1102 lfsmake2 sysvinit
1103 lfsmake2 tar
1104 lfsmake2 texinfo
1105 lfsmake2 util-linux
1106 lfsmake2 udev
1107 lfsmake2 vim
1108 }
1109
1110 buildipfire() {
1111 LOGFILE="$BASEDIR/log/_build.ipfire.log"
1112 export LOGFILE
1113 lfsmake2 configroot
1114 lfsmake2 initscripts
1115 lfsmake2 backup
1116 lfsmake2 openssl
1117 [ "${BUILD_ARCH}" = "i586" ] && lfsmake2 openssl KCFG='-sse2'
1118 lfsmake2 popt
1119 lfsmake2 libedit
1120 lfsmake2 libusb
1121 lfsmake2 libusb-compat
1122 lfsmake2 libpcap
1123 lfsmake2 ppp
1124 lfsmake2 pptp
1125 lfsmake2 unzip
1126 lfsmake2 which
1127 lfsmake2 linux-firmware
1128 lfsmake2 dvb-firmwares
1129 lfsmake2 xr819-firmware
1130 lfsmake2 zd1211-firmware
1131 lfsmake2 rpi-firmware
1132 lfsmake2 intel-microcode
1133 lfsmake2 pcengines-apu-firmware
1134 lfsmake2 bc
1135 lfsmake2 u-boot MKIMAGE=1
1136 lfsmake2 cpio
1137 lfsmake2 mdadm
1138 lfsmake2 dracut
1139 lfsmake2 libaio
1140 lfsmake2 lvm2
1141 lfsmake2 multipath-tools
1142 lfsmake2 freetype
1143 lfsmake2 libmnl
1144 lfsmake2 libnfnetlink
1145 lfsmake2 libnetfilter_queue
1146 lfsmake2 libnetfilter_conntrack
1147 lfsmake2 libnetfilter_cthelper
1148 lfsmake2 libnetfilter_cttimeout
1149 lfsmake2 iptables
1150 lfsmake2 screen
1151 lfsmake2 elfutils
1152
1153 case "${BUILD_ARCH}" in
1154 x86_64|aarch64)
1155 lfsmake2 linux KCFG=""
1156 # lfsmake2 backports KCFG=""
1157 # lfsmake2 e1000e KCFG=""
1158 # lfsmake2 igb KCFG=""
1159 # lfsmake2 ixgbe KCFG=""
1160 lfsmake2 xtables-addons KCFG=""
1161 lfsmake2 linux-initrd KCFG=""
1162 ;;
1163 i586)
1164 # x86-pae (Native and new XEN) kernel build
1165 lfsmake2 linux KCFG="-pae"
1166 # lfsmake2 backports KCFG="-pae"
1167 # lfsmake2 e1000e KCFG="-pae"
1168 # lfsmake2 igb KCFG="-pae"
1169 # lfsmake2 ixgbe KCFG="-pae"
1170 lfsmake2 xtables-addons KCFG="-pae"
1171 lfsmake2 linux-initrd KCFG="-pae"
1172
1173 # x86 kernel build
1174 lfsmake2 linux KCFG=""
1175 # lfsmake2 backports KCFG=""
1176 # lfsmake2 e1000e KCFG=""
1177 # lfsmake2 igb KCFG=""
1178 # lfsmake2 ixgbe KCFG=""
1179 lfsmake2 xtables-addons KCFG=""
1180 lfsmake2 linux-initrd KCFG=""
1181 ;;
1182
1183 armv5tel)
1184 # arm-kirkwood (Dreamplug, ICY-Box ...) kernel build
1185 lfsmake2 linux KCFG="-kirkwood"
1186 # lfsmake2 backports KCFG="-kirkwood"
1187 # lfsmake2 e1000e KCFG="-kirkwood"
1188 # lfsmake2 igb KCFG="-kirkwood"
1189 # lfsmake2 ixgbe KCFG="-kirkwood"
1190 lfsmake2 xtables-addons KCFG="-kirkwood"
1191 lfsmake2 linux-initrd KCFG="-kirkwood"
1192
1193 # arm multi platform (Panda, Wandboard ...) kernel build
1194 lfsmake2 linux KCFG="-multi"
1195 # lfsmake2 backports KCFG="-multi"
1196 # lfsmake2 e1000e KCFG="-multi"
1197 # lfsmake2 igb KCFG="-multi"
1198 # lfsmake2 ixgbe KCFG="-multi"
1199 lfsmake2 xtables-addons KCFG="-multi"
1200 lfsmake2 linux-initrd KCFG="-multi"
1201 ;;
1202 esac
1203 lfsmake2 xtables-addons USPACE="1"
1204 lfsmake2 libgpg-error
1205 lfsmake2 libgcrypt
1206 lfsmake2 libassuan
1207 lfsmake2 nettle
1208 lfsmake2 json-c
1209 lfsmake2 libconfig
1210 lfsmake2 libevent
1211 lfsmake2 libevent2
1212 lfsmake2 expat
1213 lfsmake2 apr
1214 lfsmake2 aprutil
1215 lfsmake2 unbound
1216 lfsmake2 gnutls
1217 lfsmake2 bind
1218 lfsmake2 dhcp
1219 lfsmake2 dhcpcd
1220 lfsmake2 boost
1221 lfsmake2 linux-atm
1222 lfsmake2 gdbm
1223 lfsmake2 pam
1224 lfsmake2 curl
1225 lfsmake2 tcl
1226 lfsmake2 sqlite
1227 lfsmake2 libffi
1228 lfsmake2 python
1229 lfsmake2 python3
1230 lfsmake2 grub
1231 lfsmake2 efivar
1232 lfsmake2 efibootmgr
1233 lfsmake2 ca-certificates
1234 lfsmake2 fireinfo
1235 lfsmake2 libnet
1236 lfsmake2 libnl
1237 lfsmake2 libnl-3
1238 lfsmake2 libidn
1239 lfsmake2 nasm
1240 lfsmake2 libjpeg
1241 lfsmake2 libjpeg-compat
1242 lfsmake2 libexif
1243 lfsmake2 libpng
1244 lfsmake2 libtiff
1245 lfsmake2 libart
1246 lfsmake2 gd
1247 lfsmake2 slang
1248 lfsmake2 newt
1249 lfsmake2 libsmooth
1250 lfsmake2 attr
1251 lfsmake2 acl
1252 lfsmake2 libcap
1253 lfsmake2 libcap-ng
1254 lfsmake2 pciutils
1255 lfsmake2 usbutils
1256 lfsmake2 libxml2
1257 lfsmake2 libxslt
1258 lfsmake2 BerkeleyDB
1259 lfsmake2 cyrus-sasl
1260 lfsmake2 openldap
1261 lfsmake2 apache2
1262 lfsmake2 web-user-interface
1263 lfsmake2 flag-icons
1264 lfsmake2 jquery
1265 lfsmake2 bootstrap
1266 lfsmake2 arping
1267 lfsmake2 beep
1268 lfsmake2 libarchive
1269 lfsmake2 cmake
1270 lfsmake2 libssh
1271 lfsmake2 cdrkit
1272 lfsmake2 dosfstools
1273 lfsmake2 reiserfsprogs
1274 lfsmake2 xfsprogs
1275 lfsmake2 sysfsutils
1276 lfsmake2 fuse
1277 lfsmake2 ntfs-3g
1278 lfsmake2 ethtool
1279 lfsmake2 ez-ipupdate
1280 lfsmake2 fcron
1281 lfsmake2 perl-GD
1282 lfsmake2 GD-Graph
1283 lfsmake2 GD-TextUtil
1284 lfsmake2 perl-Device-SerialPort
1285 lfsmake2 perl-Device-Modem
1286 lfsmake2 perl-Apache-Htpasswd
1287 lfsmake2 gnupg
1288 lfsmake2 hdparm
1289 lfsmake2 sdparm
1290 lfsmake2 mtools
1291 lfsmake2 whatmask
1292 lfsmake2 conntrack-tools
1293 lfsmake2 libupnp
1294 lfsmake2 ipaddr
1295 lfsmake2 iputils
1296 lfsmake2 l7-protocols
1297 lfsmake2 hwdata
1298 lfsmake2 logrotate
1299 lfsmake2 logwatch
1300 lfsmake2 misc-progs
1301 lfsmake2 nano
1302 lfsmake2 URI
1303 lfsmake2 perl-CGI
1304 lfsmake2 perl-Switch
1305 lfsmake2 HTML-Tagset
1306 lfsmake2 HTML-Parser
1307 lfsmake2 HTML-Template
1308 lfsmake2 Compress-Zlib
1309 lfsmake2 Digest
1310 lfsmake2 Digest-SHA1
1311 lfsmake2 Digest-HMAC
1312 lfsmake2 libwww-perl
1313 lfsmake2 Net-DNS
1314 lfsmake2 Net-IPv4Addr
1315 lfsmake2 Net_SSLeay
1316 lfsmake2 IO-Stringy
1317 lfsmake2 IO-Socket-SSL
1318 lfsmake2 Unix-Syslog
1319 lfsmake2 Mail-Tools
1320 lfsmake2 MIME-Tools
1321 lfsmake2 Net-Server
1322 lfsmake2 Convert-TNEF
1323 lfsmake2 Convert-UUlib
1324 lfsmake2 Archive-Tar
1325 lfsmake2 Archive-Zip
1326 lfsmake2 Text-Tabs+Wrap
1327 lfsmake2 Locale-Country
1328 lfsmake2 XML-Parser
1329 lfsmake2 Crypt-PasswdMD5
1330 lfsmake2 Net-Telnet
1331 lfsmake2 python-setuptools
1332 lfsmake2 python-clientform
1333 lfsmake2 python-mechanize
1334 lfsmake2 python-feedparser
1335 lfsmake2 python-rssdler
1336 lfsmake2 python-inotify
1337 lfsmake2 python-docutils
1338 lfsmake2 python-daemon
1339 lfsmake2 python-ipaddress
1340 lfsmake2 glib
1341 lfsmake2 GeoIP
1342 lfsmake2 geoip-database
1343 lfsmake2 ntp
1344 lfsmake2 openssh
1345 lfsmake2 fontconfig
1346 lfsmake2 dejavu-fonts-ttf
1347 lfsmake2 ubuntu-font-family
1348 lfsmake2 freefont
1349 lfsmake2 pixman
1350 lfsmake2 cairo
1351 lfsmake2 pango
1352 lfsmake2 rrdtool
1353 lfsmake2 setserial
1354 lfsmake2 setup
1355 lfsmake2 libdnet
1356 lfsmake2 rust
1357 lfsmake2 jansson
1358 lfsmake2 yaml
1359 lfsmake2 libhtp
1360 lfsmake2 colm
1361 lfsmake2 ragel
1362 lfsmake2 hyperscan
1363 lfsmake2 suricata
1364 lfsmake2 oinkmaster
1365 lfsmake2 ids-ruleset-sources
1366 lfsmake2 squid
1367 lfsmake2 squidguard
1368 lfsmake2 calamaris
1369 lfsmake2 tcpdump
1370 lfsmake2 traceroute
1371 lfsmake2 vlan
1372 lfsmake2 wireless
1373 lfsmake2 pakfire
1374 lfsmake2 spandsp
1375 lfsmake2 lz4
1376 lfsmake2 lzo
1377 lfsmake2 openvpn
1378 lfsmake2 mpage
1379 lfsmake2 dbus
1380 lfsmake2 intltool
1381 lfsmake2 libdaemon
1382 lfsmake2 avahi
1383 lfsmake2 cups
1384 lfsmake2 lcms2
1385 lfsmake2 ghostscript
1386 lfsmake2 qpdf
1387 lfsmake2 poppler
1388 lfsmake2 cups-filters
1389 lfsmake2 epson-inkjet-printer-escpr
1390 lfsmake2 foomatic
1391 lfsmake2 hplip
1392 lfsmake2 cifs-utils
1393 lfsmake2 krb5
1394 lfsmake2 samba
1395 lfsmake2 sudo
1396 lfsmake2 mc
1397 lfsmake2 wget
1398 lfsmake2 bridge-utils
1399 lfsmake2 smartmontools
1400 lfsmake2 htop
1401 lfsmake2 chkconfig
1402 lfsmake2 postfix
1403 lfsmake2 fetchmail
1404 lfsmake2 cyrus-imapd
1405 lfsmake2 clamav
1406 lfsmake2 perl-NetAddr-IP
1407 lfsmake2 spamassassin
1408 lfsmake2 perl-Net-LibIDN
1409 lfsmake2 amavisd
1410 lfsmake2 dma
1411 lfsmake2 alsa
1412 lfsmake2 mpfire
1413 lfsmake2 guardian
1414 lfsmake2 libid3tag
1415 lfsmake2 libmad
1416 lfsmake2 libogg
1417 lfsmake2 libvorbis
1418 lfsmake2 libdvbpsi
1419 lfsmake2 flac
1420 lfsmake2 lame
1421 lfsmake2 sox
1422 lfsmake2 soxr
1423 lfsmake2 libshout
1424 lfsmake2 xvid
1425 lfsmake2 libmpeg2
1426 lfsmake2 gnump3d
1427 lfsmake2 rsync
1428 lfsmake2 libtirpc
1429 lfsmake2 rpcbind
1430 lfsmake2 keyutils
1431 lfsmake2 nfs
1432 lfsmake2 gnu-netcat
1433 lfsmake2 ncat
1434 lfsmake2 nmap
1435 lfsmake2 etherwake
1436 lfsmake2 bwm-ng
1437 lfsmake2 sysstat
1438 lfsmake2 strongswan
1439 lfsmake2 rng-tools
1440 lfsmake2 lsof
1441 lfsmake2 br2684ctl
1442 lfsmake2 pcmciautils
1443 lfsmake2 lm_sensors
1444 lfsmake2 liboping
1445 lfsmake2 collectd
1446 lfsmake2 elinks
1447 lfsmake2 igmpproxy
1448 lfsmake2 fbset
1449 lfsmake2 opus
1450 lfsmake2 python-six
1451 lfsmake2 python-pyparsing
1452 lfsmake2 spice-protocol
1453 lfsmake2 spice
1454 lfsmake2 sdl
1455 lfsmake2 libusbredir
1456 lfsmake2 libseccomp
1457 lfsmake2 qemu
1458 lfsmake2 sane
1459 lfsmake2 netpbm
1460 lfsmake2 netsnmpd
1461 lfsmake2 nagios_nrpe
1462 lfsmake2 nagios-plugins
1463 lfsmake2 icinga
1464 lfsmake2 observium-agent
1465 lfsmake2 ebtables
1466 lfsmake2 directfb
1467 lfsmake2 faad2
1468 lfsmake2 alac
1469 lfsmake2 ffmpeg
1470 lfsmake2 vdr
1471 lfsmake2 vdr_streamdev
1472 lfsmake2 vdr_epgsearch
1473 lfsmake2 vdr_dvbapi
1474 lfsmake2 vdr_eepg
1475 lfsmake2 w_scan
1476 lfsmake2 icecast
1477 lfsmake2 icegenerator
1478 lfsmake2 mpd
1479 lfsmake2 libmpdclient
1480 lfsmake2 mpc
1481 lfsmake2 perl-Net-CIDR-Lite
1482 lfsmake2 perl-Net-SMTP-SSL
1483 lfsmake2 perl-MIME-Base64
1484 lfsmake2 perl-Authen-SASL
1485 lfsmake2 perl-MIME-Lite
1486 lfsmake2 perl-Email-Date-Format
1487 lfsmake2 git
1488 lfsmake2 squidclamav
1489 lfsmake2 vnstat
1490 lfsmake2 iw
1491 lfsmake2 wpa_supplicant
1492 lfsmake2 hostapd
1493 lfsmake2 pycurl
1494 lfsmake2 urlgrabber
1495 lfsmake2 syslinux
1496 lfsmake2 tftpd
1497 lfsmake2 cpufrequtils
1498 lfsmake2 bluetooth
1499 lfsmake2 gutenprint
1500 lfsmake2 apcupsd
1501 lfsmake2 iperf
1502 lfsmake2 iperf3
1503 lfsmake2 7zip
1504 lfsmake2 lynis
1505 lfsmake2 streamripper
1506 lfsmake2 sshfs
1507 lfsmake2 taglib
1508 lfsmake2 sslh
1509 lfsmake2 perl-gettext
1510 lfsmake2 perl-Sort-Naturally
1511 lfsmake2 vdradmin
1512 lfsmake2 perl-DBI
1513 lfsmake2 perl-DBD-SQLite
1514 lfsmake2 perl-File-ReadBackwards
1515 lfsmake2 openvmtools
1516 lfsmake2 motion
1517 lfsmake2 joe
1518 lfsmake2 monit
1519 lfsmake2 nut
1520 lfsmake2 watchdog
1521 lfsmake2 libpri
1522 lfsmake2 libsrtp
1523 lfsmake2 asterisk
1524 lfsmake2 usb_modeswitch
1525 lfsmake2 usb_modeswitch_data
1526 lfsmake2 zerofree
1527 lfsmake2 minicom
1528 lfsmake2 ddrescue
1529 lfsmake2 miniupnpd
1530 lfsmake2 client175
1531 lfsmake2 powertop
1532 lfsmake2 parted
1533 lfsmake2 swig
1534 lfsmake2 u-boot
1535 lfsmake2 u-boot-kirkwood
1536 lfsmake2 u-boot-friendlyarm
1537 lfsmake2 python-typing
1538 lfsmake2 python-m2crypto
1539 lfsmake2 wireless-regdb
1540 lfsmake2 crda
1541 lfsmake2 libsolv
1542 lfsmake2 python-distutils-extra
1543 lfsmake2 python-lzma
1544 lfsmake2 python-progressbar
1545 lfsmake2 python-xattr
1546 lfsmake2 ddns
1547 lfsmake2 python3-setuptools
1548 lfsmake2 python3-setuptools-scm
1549 lfsmake2 python3-six
1550 lfsmake2 python3-dateutil
1551 lfsmake2 python3-jmespath
1552 lfsmake2 python3-colorama
1553 lfsmake2 python3-docutils
1554 lfsmake2 python3-yaml
1555 lfsmake2 python3-s3transfer
1556 lfsmake2 python3-rsa
1557 lfsmake2 python3-pyasn1
1558 lfsmake2 python3-botocore
1559 lfsmake2 python3-llfuse
1560 lfsmake2 python3-msgpack
1561 lfsmake2 aws-cli
1562 lfsmake2 transmission
1563 lfsmake2 dpfhack
1564 lfsmake2 lcd4linux
1565 lfsmake2 mtr
1566 lfsmake2 minidlna
1567 lfsmake2 acpid
1568 lfsmake2 fping
1569 lfsmake2 telnet
1570 lfsmake2 xinetd
1571 lfsmake2 gpgme
1572 lfsmake2 pygpgme
1573 lfsmake2 pakfire3
1574 lfsmake2 stress
1575 lfsmake2 libstatgrab
1576 lfsmake2 sarg
1577 lfsmake2 check_mk_agent
1578 lfsmake2 nginx
1579 lfsmake2 sendEmail
1580 lfsmake2 sysbench
1581 lfsmake2 strace
1582 lfsmake2 ltrace
1583 lfsmake2 ipfire-netboot
1584 lfsmake2 lcdproc
1585 lfsmake2 bitstream
1586 lfsmake2 multicat
1587 lfsmake2 keepalived
1588 lfsmake2 ipvsadm
1589 lfsmake2 perl-Carp-Clan
1590 lfsmake2 perl-Date-Calc
1591 lfsmake2 perl-Date-Manip
1592 lfsmake2 perl-File-Tail
1593 lfsmake2 perl-TimeDate
1594 lfsmake2 swatch
1595 lfsmake2 tor
1596 lfsmake2 arm
1597 lfsmake2 wavemon
1598 lfsmake2 iptraf-ng
1599 lfsmake2 iotop
1600 lfsmake2 stunnel
1601 lfsmake2 bacula
1602 lfsmake2 batctl
1603 lfsmake2 perl-Font-TTF
1604 lfsmake2 perl-IO-String
1605 lfsmake2 perl-PDF-API2
1606 lfsmake2 squid-accounting
1607 lfsmake2 pigz
1608 lfsmake2 tmux
1609 lfsmake2 perl-Text-CSV_XS
1610 lfsmake2 haproxy
1611 lfsmake2 ipset
1612 lfsmake2 lua
1613 lfsmake2 dnsdist
1614 lfsmake2 bird
1615 lfsmake2 frr
1616 lfsmake2 dmidecode
1617 lfsmake2 mcelog
1618 lfsmake2 rtpproxy
1619 lfsmake2 util-macros
1620 lfsmake2 libpciaccess
1621 lfsmake2 libyajl
1622 lfsmake2 libvirt
1623 lfsmake2 freeradius
1624 lfsmake2 perl-common-sense
1625 lfsmake2 perl-inotify2
1626 lfsmake2 perl-Net-IP
1627 lfsmake2 wio
1628 lfsmake2 iftop
1629 lfsmake2 mdns-repeater
1630 lfsmake2 i2c-tools
1631 lfsmake2 nss-myhostname
1632 lfsmake2 dehydrated
1633 lfsmake2 shairport-sync
1634 lfsmake2 borgbackup
1635 lfsmake2 knot
1636 lfsmake2 spectre-meltdown-checker
1637 lfsmake2 zabbix_agentd
1638 lfsmake2 flashrom
1639 lfsmake2 firmware-update
1640 lfsmake2 tshark
1641 lfsmake2 geoip-generator
1642 lfsmake2 speedtest-cli
1643 lfsmake2 rfkill
1644 lfsmake2 amazon-ssm-agent
1645 }
1646
1647 buildinstaller() {
1648 # Run installer scripts one by one
1649 LOGFILE="$BASEDIR/log/_build.installer.log"
1650 export LOGFILE
1651 lfsmake2 memtest
1652 lfsmake2 installer
1653 # use toolchain bash for chroot to strip
1654 EXTRA_PATH=${TOOLS_DIR}/bin/ lfsmake2 strip
1655 }
1656
1657 buildpackages() {
1658 LOGFILE="$BASEDIR/log/_build.packages.log"
1659 export LOGFILE
1660 echo "... see detailed log in _build.*.log files" >> $LOGFILE
1661
1662
1663 # Generating list of packages used
1664 print_line "Generating packages list from logs"
1665 rm -f $BASEDIR/doc/packages-list
1666 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
1667 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
1668 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
1669 fi
1670 done
1671 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
1672 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
1673 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
1674 rm -f $BASEDIR/doc/packages-list
1675 # packages-list.txt is ready to be displayed for wiki page
1676 print_status DONE
1677
1678 # Update changelog
1679 cd $BASEDIR
1680 [ -z $GIT_TAG ] || LAST_TAG=$GIT_TAG
1681 [ -z $LAST_TAG ] || EXT="$LAST_TAG..HEAD"
1682 git log -n 500 --no-merges --pretty=medium --shortstat $EXT > $BASEDIR/doc/ChangeLog
1683
1684 # Create images for install
1685 lfsmake2 cdrom
1686
1687 # Check if there is a loop device for building in virtual environments
1688 modprobe loop 2>/dev/null
1689 if [ $BUILD_IMAGES == 1 ] && ([ -e /dev/loop/0 ] || [ -e /dev/loop0 ] || [ -e "/dev/loop-control" ]); then
1690 lfsmake2 flash-images
1691 fi
1692
1693 mv $LFS/install/images/{*.iso,*.img.xz,*.bz2} $BASEDIR >> $LOGFILE 2>&1
1694
1695 ipfirepackages
1696
1697 lfsmake2 xen-image
1698 mv $LFS/install/images/*.bz2 $BASEDIR >> $LOGFILE 2>&1
1699
1700 cd $BASEDIR
1701
1702 # remove not useable iso on armv5tel (needed to build flash images)
1703 [ "${BUILD_ARCH}" = "armv5tel" ] && rm -rf *.iso
1704
1705 for i in `ls *.bz2 *.img.xz *.iso`; do
1706 md5sum $i > $i.md5
1707 done
1708 cd $PWD
1709
1710 # Cleanup
1711 stdumount
1712 rm -rf $BASEDIR/build/tmp/*
1713
1714 cd $PWD
1715 }
1716
1717 ipfirepackages() {
1718 lfsmake2 core-updates
1719
1720 local i
1721 for i in $(find $BASEDIR/config/rootfiles/packages{/${BUILD_ARCH},} -maxdepth 1 -type f); do
1722 i=$(basename ${i})
1723 if [ -e $BASEDIR/lfs/$i ]; then
1724 ipfiredist $i
1725 else
1726 echo -n $i
1727 print_status SKIP
1728 fi
1729 done
1730 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
1731 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
1732 rm -rf $BASEDIR/build/install/packages/*
1733 }
1734
1735 while [ $# -gt 0 ]; do
1736 case "${1}" in
1737 --target=*)
1738 configure_build "${1#--target=}"
1739 ;;
1740 -*)
1741 exiterror "Unknown configuration option: ${1}"
1742 ;;
1743 *)
1744 # Found a command, so exit options parsing.
1745 break
1746 ;;
1747 esac
1748 shift
1749 done
1750
1751 # See what we're supposed to do
1752 case "$1" in
1753 build)
1754 START_TIME=$(now)
1755
1756 # Clear screen
1757 ${INTERACTIVE} && clear
1758
1759 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz 2> /dev/null | head -n 1`
1760 #only restore on a clean disk
1761 if [ ! -e "${BASEDIR}/build${TOOLS_DIR}/.toolchain-successful" ]; then
1762 if [ ! -n "$PACKAGE" ]; then
1763 print_build_stage "Full toolchain compilation"
1764 prepareenv
1765 buildtoolchain
1766 else
1767 PACKAGENAME=${PACKAGE%.tar.xz}
1768 print_build_stage "Packaged toolchain compilation"
1769 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
1770 tar axf $PACKAGE
1771 prepareenv
1772 else
1773 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
1774 fi
1775 fi
1776 else
1777 prepareenv
1778 fi
1779
1780 print_build_stage "Building LFS"
1781 buildbase
1782
1783 print_build_stage "Building IPFire"
1784 buildipfire
1785
1786 print_build_stage "Building installer"
1787 buildinstaller
1788
1789 print_build_stage "Building packages"
1790 buildpackages
1791
1792 print_build_stage "Checking Logfiles for new Files"
1793
1794 cd $BASEDIR
1795 tools/checknewlog.pl
1796 tools/checkrootfiles
1797 cd $PWD
1798
1799 print_build_summary $(( $(now) - ${START_TIME} ))
1800 ;;
1801 shell)
1802 # enter a shell inside LFS chroot
1803 # may be used to changed kernel settings
1804 prepareenv
1805 entershell
1806 ;;
1807 clean)
1808 print_line "Cleaning build directory..."
1809
1810 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
1811 $LOSETUP -d $i 2>/dev/null
1812 done
1813 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
1814 umount $i
1815 done
1816 stdumount
1817 for i in `seq 0 7`; do
1818 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
1819 umount /dev/loop${i} 2>/dev/null;
1820 losetup -d /dev/loop${i} 2>/dev/null;
1821 fi;
1822 done
1823 rm -rf $BASEDIR/build
1824 rm -rf $BASEDIR/cdrom
1825 rm -rf $BASEDIR/packages
1826 rm -rf $BASEDIR/log
1827 if [ -h "${TOOLS_DIR}" ]; then
1828 rm -f "${TOOLS_DIR}"
1829 fi
1830 rm -f $BASEDIR/ipfire-*
1831 print_status DONE
1832 ;;
1833 docker)
1834 # Build the docker image if it does not exist, yet
1835 if ! docker images -a | grep -q ^ipfire-builder; then
1836 if docker build -t ipfire-builder ${BASEDIR}/tools/docker; then
1837 print_status DONE
1838 else
1839 print_status FAIL
1840 exit 1
1841 fi
1842 fi
1843
1844 # Run the container and enter a shell
1845 docker run -it --privileged -v "${BASEDIR}:/build" -w "/build" ipfire-builder bash -l
1846 ;;
1847 downloadsrc)
1848 if [ ! -d $BASEDIR/cache ]; then
1849 mkdir $BASEDIR/cache
1850 fi
1851 mkdir -p $BASEDIR/log
1852 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
1853 FINISHED=0
1854 cd $BASEDIR/lfs
1855 for c in `seq $MAX_RETRIES`; do
1856 if (( FINISHED==1 )); then
1857 break
1858 fi
1859 FINISHED=1
1860 cd $BASEDIR/lfs
1861 for i in *; do
1862 if [ -f "$i" -a "$i" != "Config" ]; then
1863 lfsmakecommoncheck ${i} || continue
1864
1865 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
1866 MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
1867 if [ $? -ne 0 ]; then
1868 print_status FAIL
1869 FINISHED=0
1870 else
1871 if [ $c -eq 1 ]; then
1872 print_status DONE
1873 fi
1874 fi
1875 fi
1876 done
1877 done
1878 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
1879 ERROR=0
1880 for i in *; do
1881 if [ -f "$i" -a "$i" != "Config" ]; then
1882 lfsmakecommoncheck ${i} > /dev/null || continue
1883 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
1884 MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
1885 if [ $? -ne 0 ]; then
1886 echo -ne "MD5 difference in lfs/$i"
1887 print_status FAIL
1888 ERROR=1
1889 fi
1890 fi
1891 done
1892 if [ $ERROR -eq 0 ]; then
1893 echo -ne "${BOLD}all files md5sum match${NORMAL}"
1894 print_status DONE
1895 else
1896 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
1897 print_status FAIL
1898 fi
1899 cd - >/dev/null 2>&1
1900 ;;
1901 toolchain)
1902 # Clear screen
1903 ${INTERACTIVE} && clear
1904
1905 prepareenv
1906 print_build_stage "Toolchain compilation (${BUILD_ARCH})"
1907 buildtoolchain
1908 echo "`date -u '+%b %e %T'`: Create toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
1909 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
1910 cd $BASEDIR && tar -cf- --exclude='log/_build.*.log' build/${TOOLS_DIR} build/bin/sh log | xz ${XZ_OPT} \
1911 > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz
1912 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz \
1913 > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.md5
1914 stdumount
1915 ;;
1916 gettoolchain)
1917 # arbitrary name to be updated in case of new toolchain package upload
1918 PACKAGE=$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}
1919 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.xz ]; then
1920 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
1921 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
1922 echo "`date -u '+%b %e %T'`: Load toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
1923 cd $BASEDIR/cache/toolchains
1924 wget -U "IPFireSourceGrabber/2.x" $URL_TOOLCHAIN/$PACKAGE.tar.xz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
1925 if [ $? -ne 0 ]; then
1926 echo "`date -u '+%b %e %T'`: error downloading $PACKAGE toolchain for ${BUILD_ARCH} machine" | tee -a $LOGFILE
1927 else
1928 if [ "`md5sum $PACKAGE.tar.xz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
1929 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
1930 else
1931 exiterror "$PACKAGE.md5 did not match, check downloaded package"
1932 fi
1933 fi
1934 else
1935 echo "Toolchain is already downloaded. Exiting..."
1936 fi
1937 ;;
1938 uploadsrc)
1939 PWD=`pwd`
1940 if [ -z $IPFIRE_USER ]; then
1941 echo -n "You have to setup IPFIRE_USER first. See .config for details."
1942 print_status FAIL
1943 exit 1
1944 fi
1945
1946 URL_SOURCE=$(grep URL_SOURCE lfs/Config | awk '{ print $3 }')
1947 REMOTE_FILES=$(echo "ls -1" | sftp -C ${IPFIRE_USER}@${URL_SOURCE})
1948
1949 for file in ${BASEDIR}/cache/*; do
1950 [ -d "${file}" ] && continue
1951 grep -q "$(basename ${file})" <<<$REMOTE_FILES && continue
1952 NEW_FILES="$NEW_FILES $file"
1953 done
1954 [ -n "$NEW_FILES" ] && scp -2 $NEW_FILES ${IPFIRE_USER}@${URL_SOURCE}
1955 cd $BASEDIR
1956 cd $PWD
1957 exit 0
1958 ;;
1959 lang)
1960 echo -ne "Checking the translations for missing or obsolete strings..."
1961 chmod 755 $BASEDIR/tools/{check_strings.pl,sort_strings.pl,check_langs.sh}
1962 $BASEDIR/tools/sort_strings.pl en
1963 $BASEDIR/tools/sort_strings.pl de
1964 $BASEDIR/tools/sort_strings.pl fr
1965 $BASEDIR/tools/sort_strings.pl es
1966 $BASEDIR/tools/sort_strings.pl pl
1967 $BASEDIR/tools/sort_strings.pl ru
1968 $BASEDIR/tools/sort_strings.pl nl
1969 $BASEDIR/tools/sort_strings.pl tr
1970 $BASEDIR/tools/sort_strings.pl it
1971 $BASEDIR/tools/check_strings.pl en > $BASEDIR/doc/language_issues.en
1972 $BASEDIR/tools/check_strings.pl de > $BASEDIR/doc/language_issues.de
1973 $BASEDIR/tools/check_strings.pl fr > $BASEDIR/doc/language_issues.fr
1974 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.es
1975 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.pl
1976 $BASEDIR/tools/check_strings.pl ru > $BASEDIR/doc/language_issues.ru
1977 $BASEDIR/tools/check_strings.pl nl > $BASEDIR/doc/language_issues.nl
1978 $BASEDIR/tools/check_strings.pl tr > $BASEDIR/doc/language_issues.tr
1979 $BASEDIR/tools/check_strings.pl it > $BASEDIR/doc/language_issues.it
1980 $BASEDIR/tools/check_langs.sh > $BASEDIR/doc/language_missings
1981 print_status DONE
1982
1983 echo -ne "Updating language lists..."
1984 update_language_list ${BASEDIR}/src/installer/po
1985 update_language_list ${BASEDIR}/src/setup/po
1986 print_status DONE
1987 ;;
1988 update-contributors)
1989 update_contributors
1990 ;;
1991 *)
1992 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain|update-contributors}"
1993 cat doc/make.sh-usage
1994 ;;
1995 esac